// Customer.cpp : Implementation of CCustomer
#include "stdafx.h"
#include "ShopCOM.h"
#include "Customer.h"

/////////////////////////////////////////////////////////////////////////////
// CCustomer

STDMETHODIMP CCustomer::GetByID(BSTR strUser, BSTR strPass, LONG lCustomerID, _Recordset **rsCustomer)
{
	//
	// validar o utilizador
	//
	if( ::ValidateUser(strUser, strPass) != SHOP_STATUS_OK )
	{
		*rsCustomer = NULL;
		return S_OK;
	}

	//
	// efectuar o select, retornar o recordset no parametro de output
	//
	*rsCustomer = ::GetByID("customers", "customerID", lCustomerID);

	//
	// retornar sucesso para COM
	//
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////

STDMETHODIMP CCustomer::FindByName(BSTR strUser, BSTR strPass, BSTR strNamePattern, _Recordset **rsCustomers)
{

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////

STDMETHODIMP CCustomer::AddCustomer(BSTR strUser, BSTR strPass, BSTR strName, BSTR strAddress, BSTR strPhone, BSTR strFax, BSTR strEmail, LONG *lStatus, LONG *lCustomerID)
{

	//
	// validar o utilizador
	//
	if( (*lStatus = ::ValidateUser(strUser, strPass)) != SHOP_STATUS_OK )
	{
		*lCustomerID = -1L;
		return S_OK;
	}

	_RecordsetPtr spRs = NULL;
	_bstr_t strCmd;

	try 
	{
		//
		// criar um recordset para a insero
		// no uso comando SQL pois quero obter a chave auto-gerada do registo
		//
		TESTAHR( spRs.CreateInstance(__uuidof(Recordset)) );

		//
		// configurar recodset, cursor do lado do cliente
		//
		spRs->PutCursorLocation(adUseClient);

		//
		// definir o comando SQL a executar 
		// apenas para construir o esquema da BD
		//
		strCmd = _bstr_t("SELECT * FROM customers WHERE 1=2");

		//
		// executar o comando e construir o recordset
		//
		spRs->Open(strCmd, strConn, adOpenKeyset, adLockOptimistic, -1L); 

		//
		// inserir valores
		//
		spRs->AddNew();
			spRs->Fields->GetItem("Name")->Value	= strName;
			spRs->Fields->GetItem("Address")->Value = strAddress;
			spRs->Fields->GetItem("PhoneNb")->Value = strPhone;
			spRs->Fields->GetItem("FaxNb")->Value	= strFax;
			spRs->Fields->GetItem("Email")->Value	= strEmail;
		spRs->Update();

		// inseriu registo
		*lStatus = SHOP_STATUS_OK;

		//
		// no registo, o campo com a chave deve estar agora preenchido
		//
		*lCustomerID = spRs->Fields->GetItem("CustomerID")->Value.lVal; 
	}
	catch(_com_error &e)
	{
		::MessageBox(NULL, e.Description(), "Erro", MB_OK);

		*lStatus = SHOP_STATUS_COM_ERROR;
	}

	//
	// retornar sucesso ao COM
	//
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////

STDMETHODIMP CCustomer::UpdateCustomerData(BSTR strUser, BSTR strPass, LONG lCustomerID, BSTR strName, BSTR strAddress, BSTR strPhone, BSTR strFax, BSTR strEmail, LONG *lStatus)
{
	//
	// validar utilizador
	//
	if( (*lStatus = ::ValidateUser(strUser, strPass)) != SHOP_STATUS_OK ) 
		return S_OK;

	_ConnectionPtr spConn = NULL;
	_variant_t vtRows((short)0);
	_bstr_t strCmd;

	try 
	{
		//
		// criar conexo
		//
		TESTAHR( spConn.CreateInstance(__uuidof(Connection)) );

		//
		// construir um comando SQL para executar
		//
		strCmd = _bstr_t("UPDATE customers SET ")			+
				 _bstr_t("name = '")		+ strName		+ 
				 _bstr_t("', address = '")	+ strAddress	+ 
				 _bstr_t("', phoneNb = '")	+ strPhone		+ 
				 _bstr_t("', faxNb = '")	+ strFax		+ 
				 _bstr_t("', email = '")	+ strEmail		+ 
				 _bstr_t("' WHERE customerId = ") + _bstr_t(lCustomerID);


		//
		// abrir conexo
		//
		spConn->Open(strConn, "", "", adConnectUnspecified);

		//
		// executar o comando
		//
		spConn->Execute(strCmd, &vtRows, adCmdText);

		//
		// verificar o resultado
		//
		if ( long(vtRows) == 0L )// no actualizou registo
			
			*lStatus = SHOP_STATUS_NOT_OK;

		else 					// actualizou registo

			*lStatus = SHOP_STATUS_OK;
	}
	catch(_com_error &e)
	{
		::MessageBox(NULL, e.Description(), "Erro", MB_OK);

		*lStatus = SHOP_STATUS_COM_ERROR;
	}

	//
	// retornar sucesso ao COM
	//
	return S_OK;
}
