// Customer.h : Declaration of the CCustomer

#ifndef __CUSTOMER_H_
#define __CUSTOMER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CCustomer
class ATL_NO_VTABLE CCustomer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCustomer, &CLSID_Customer>,
	public IDispatchImpl<ICustomer, &IID_ICustomer, &LIBID_SHOPCOMLib>
{
public:
	CCustomer()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CUSTOMER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCustomer)
	COM_INTERFACE_ENTRY(ICustomer)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICustomer
public:
	STDMETHOD(UpdateCustomerData)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[in]*/ LONG lCustomerID, /*[in]*/ BSTR strName, /*[in]*/ BSTR strAddress, /*[in]*/ BSTR strPhone, /*[in]*/ BSTR strFax, /*[in]*/ BSTR strEmail, /*[out, retval]*/ LONG * lStatus);
	STDMETHOD(AddCustomer)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[in]*/ BSTR strName, /*[in]*/ BSTR strAddress, /*[in]*/ BSTR strPhone, /*[in]*/ BSTR strFax, /*[in]*/ BSTR strEmail, /*[out]*/ LONG * lStatus, /*[out, retval]*/ LONG * lCustomerID);
	STDMETHOD(FindByName)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[in]*/ BSTR strNamePattern, /*[out, retval]*/ _Recordset ** rsCustomers);
	STDMETHOD(GetByID)(/*[in]*/ BSTR strUser, /*[in]*/ BSTR strPass, /*[in]*/ LONG lCustomerID, /*[out, retval]*/ _Recordset ** rsCustomer);

};

#endif //__CUSTOMER_H_
